/* imap-store-command.c generated by valac 0.50.1, the Vala compiler
 * generated from imap-store-command.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	GEARY_IMAP_STORE_COMMAND_0_PROPERTY,
	GEARY_IMAP_STORE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* geary_imap_store_command_properties[GEARY_IMAP_STORE_COMMAND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer geary_imap_store_command_parent_class = NULL;

static GType geary_imap_store_command_get_type_once (void);

/**
     * Options indicating functionality of the {@link StoreCommand}.
     *
     * Note that {@link ADD_FLAGS} and {@link REMOVE_FLAGS} are mutally exclusive.  REMOVE_FLAGS
     * actually does not set a bit, meaning that removing is the default operation and, if both
     * add and remove are set, an add occurs.
     */
G_GNUC_NO_INLINE static GType
geary_imap_store_command_option_get_type_once (void)
{
	static const GFlagsValue values[] = {{GEARY_IMAP_STORE_COMMAND_OPTION_REMOVE_FLAGS, "GEARY_IMAP_STORE_COMMAND_OPTION_REMOVE_FLAGS", "remove-flags"}, {GEARY_IMAP_STORE_COMMAND_OPTION_ADD_FLAGS, "GEARY_IMAP_STORE_COMMAND_OPTION_ADD_FLAGS", "add-flags"}, {GEARY_IMAP_STORE_COMMAND_OPTION_SILENT, "GEARY_IMAP_STORE_COMMAND_OPTION_SILENT", "silent"}, {0, NULL, NULL}};
	GType geary_imap_store_command_option_type_id;
	geary_imap_store_command_option_type_id = g_flags_register_static ("GearyImapStoreCommandOption", values);
	return geary_imap_store_command_option_type_id;
}

GType
geary_imap_store_command_option_get_type (void)
{
	static volatile gsize geary_imap_store_command_option_type_id__volatile = 0;
	if (g_once_init_enter (&geary_imap_store_command_option_type_id__volatile)) {
		GType geary_imap_store_command_option_type_id;
		geary_imap_store_command_option_type_id = geary_imap_store_command_option_get_type_once ();
		g_once_init_leave (&geary_imap_store_command_option_type_id__volatile, geary_imap_store_command_option_type_id);
	}
	return geary_imap_store_command_option_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GearyImapStoreCommand*
geary_imap_store_command_construct (GType object_type,
                                    GearyImapMessageSet* message_set,
                                    GeeList* flag_list,
                                    GearyImapStoreCommandOption options,
                                    GCancellable* should_send)
{
	GearyImapStoreCommand * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean add_flag = FALSE;
	gboolean silent = FALSE;
	GearyImapListParameter* _tmp3_;
	GearyImapListParameter* _tmp4_;
	GearyImapParameter* _tmp5_;
	GearyImapParameter* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	GearyImapListParameter* _tmp9_;
	GearyImapListParameter* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GearyImapAtomParameter* _tmp13_;
	GearyImapAtomParameter* _tmp14_;
	GearyImapListParameter* list = NULL;
	GearyImapListParameter* _tmp15_;
	GearyImapListParameter* _tmp30_;
	GearyImapListParameter* _tmp31_;
	GearyImapListParameter* _tmp32_;
	g_return_val_if_fail (GEARY_IMAP_IS_MESSAGE_SET (message_set), NULL);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (flag_list, GEE_TYPE_LIST), NULL);
	g_return_val_if_fail ((should_send == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (should_send, g_cancellable_get_type ()), NULL);
	_tmp1_ = geary_imap_message_set_get_is_uid (message_set);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = GEARY_IMAP_STORE_COMMAND_UID_NAME;
	} else {
		_tmp0_ = GEARY_IMAP_STORE_COMMAND_NAME;
	}
	self = (GearyImapStoreCommand*) geary_imap_command_construct (object_type, _tmp0_, NULL, (gint) 0, should_send);
	add_flag = (options & GEARY_IMAP_STORE_COMMAND_OPTION_ADD_FLAGS) != 0;
	silent = (options & GEARY_IMAP_STORE_COMMAND_OPTION_SILENT) != 0;
	_tmp3_ = geary_imap_command_get_args (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand));
	_tmp4_ = _tmp3_;
	_tmp5_ = geary_imap_message_set_to_parameter (message_set);
	_tmp6_ = _tmp5_;
	geary_imap_list_parameter_add (_tmp4_, _tmp6_);
	_g_object_unref0 (_tmp6_);
	if (add_flag) {
		_tmp7_ = "+";
	} else {
		_tmp7_ = "-";
	}
	if (silent) {
		_tmp8_ = ".silent";
	} else {
		_tmp8_ = "";
	}
	_tmp9_ = geary_imap_command_get_args (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand));
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strdup_printf ("%sflags%s", _tmp7_, _tmp8_);
	_tmp12_ = _tmp11_;
	_tmp13_ = geary_imap_atom_parameter_new (_tmp12_);
	_tmp14_ = _tmp13_;
	geary_imap_list_parameter_add (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
	_g_object_unref0 (_tmp14_);
	_g_free0 (_tmp12_);
	_tmp15_ = geary_imap_list_parameter_new ();
	list = _tmp15_;
	{
		GeeList* _flag_list = NULL;
		GeeList* _tmp16_;
		gint _flag_size = 0;
		GeeList* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gint _flag_index = 0;
		_tmp16_ = _g_object_ref0 (flag_list);
		_flag_list = _tmp16_;
		_tmp17_ = _flag_list;
		_tmp18_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
		_tmp19_ = _tmp18_;
		_flag_size = _tmp19_;
		_flag_index = -1;
		while (TRUE) {
			gint _tmp20_;
			gint _tmp21_;
			GearyImapMessageFlag* flag = NULL;
			GeeList* _tmp22_;
			gpointer _tmp23_;
			GearyImapListParameter* _tmp24_;
			GearyImapMessageFlag* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			GearyImapAtomParameter* _tmp28_;
			GearyImapAtomParameter* _tmp29_;
			_flag_index = _flag_index + 1;
			_tmp20_ = _flag_index;
			_tmp21_ = _flag_size;
			if (!(_tmp20_ < _tmp21_)) {
				break;
			}
			_tmp22_ = _flag_list;
			_tmp23_ = gee_list_get (_tmp22_, _flag_index);
			flag = (GearyImapMessageFlag*) _tmp23_;
			_tmp24_ = list;
			_tmp25_ = flag;
			_tmp26_ = geary_imap_flag_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEARY_IMAP_TYPE_FLAG, GearyImapFlag));
			_tmp27_ = _tmp26_;
			_tmp28_ = geary_imap_atom_parameter_new (_tmp27_);
			_tmp29_ = _tmp28_;
			geary_imap_list_parameter_add (_tmp24_, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
			_g_object_unref0 (_tmp29_);
			_g_object_unref0 (flag);
		}
		_g_object_unref0 (_flag_list);
	}
	_tmp30_ = geary_imap_command_get_args (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_IMAP_TYPE_COMMAND, GearyImapCommand));
	_tmp31_ = _tmp30_;
	_tmp32_ = list;
	geary_imap_list_parameter_add (_tmp31_, G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEARY_IMAP_TYPE_PARAMETER, GearyImapParameter));
	_g_object_unref0 (list);
	return self;
}

GearyImapStoreCommand*
geary_imap_store_command_new (GearyImapMessageSet* message_set,
                              GeeList* flag_list,
                              GearyImapStoreCommandOption options,
                              GCancellable* should_send)
{
	return geary_imap_store_command_construct (GEARY_IMAP_TYPE_STORE_COMMAND, message_set, flag_list, options, should_send);
}

static void
geary_imap_store_command_class_init (GearyImapStoreCommandClass * klass,
                                     gpointer klass_data)
{
	geary_imap_store_command_parent_class = g_type_class_peek_parent (klass);
}

static void
geary_imap_store_command_instance_init (GearyImapStoreCommand * self,
                                        gpointer klass)
{
}

/**
 * See [[http://tools.ietf.org/html/rfc3501#section-6.4.6]]
 *
 * @see FetchCommand
 * @see FetchedData
 */
G_GNUC_NO_INLINE static GType
geary_imap_store_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapStoreCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_store_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapStoreCommand), 0, (GInstanceInitFunc) geary_imap_store_command_instance_init, NULL };
	GType geary_imap_store_command_type_id;
	geary_imap_store_command_type_id = g_type_register_static (GEARY_IMAP_TYPE_COMMAND, "GearyImapStoreCommand", &g_define_type_info, 0);
	return geary_imap_store_command_type_id;
}

GType
geary_imap_store_command_get_type (void)
{
	static volatile gsize geary_imap_store_command_type_id__volatile = 0;
	if (g_once_init_enter (&geary_imap_store_command_type_id__volatile)) {
		GType geary_imap_store_command_type_id;
		geary_imap_store_command_type_id = geary_imap_store_command_get_type_once ();
		g_once_init_leave (&geary_imap_store_command_type_id__volatile, geary_imap_store_command_type_id);
	}
	return geary_imap_store_command_type_id__volatile;
}

